using System;
using System.Collections.Generic;

namespace MoneyManagerNET.Model
{
    public interface IEntityBus
    {
        IEnumerable<TEntity> Select<TEntity>(Func< TEntity,bool> where) where TEntity : class;
        TEntity New<TEntity>() where TEntity : class;
        void Delete<TEntity>(TEntity entity) where TEntity : class;
        void SaveAll();
        void Reset();
    }
}
