﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace MoneyManagerNET.Presentation.View
{
    using Presentation.ViewModel;
    /// <summary>
    /// Interaction logic for NewAccountView.xaml
    /// </summary>
    public partial class CreateAccountView : Window, IView<CreateAccountViewModel>
    {
        public CreateAccountView()
        {
            InitializeComponent();
        }

        private void Click_Finish(object sender, RoutedEventArgs e)
        {
            this.ViewModel().Finish();
            this.DialogResult = this.ViewModel().DialogResult;
            Close();
        }

        private void Click_Cancel(object sender, RoutedEventArgs e)
        {
            this.DialogResult = this.ViewModel().DialogResult;
            Close();
        }
    }
}
