﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.Specialized;

namespace MoneyManagerNET.Presentation.Infrastructure.Collections
{
    /*
     * TODO: consider usages, Dynamic wrappers do this for me
     */
    public class ObservableCollection<T>:System.Collections.ObjectModel.ObservableCollection<T>
    {
        public void RaisePropertyChanged(T item, string property) {
            this.OnCollectionChanged(new NotifyCollectionChangedEventArgs(NotifyCollectionChangedAction.Replace,item,item)); 
            OnPropertyChanged(new System.ComponentModel.PropertyChangedEventArgs( property));
        }

        public ObservableCollection(IEnumerable<T> e):base(e)
        {

        }
    }
}
