﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace MoneyManagerNET.Presentation.View
{
    using Presentation.ViewModel;
    using Presentation.View;
    using Model;
    using System.Diagnostics;
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window,IView<MainWindowViewModel>
    {
        public MainWindow()
        {

            try
            {
                DataContext = new Presentation.ViewModel.MainWindowViewModel(); 
            }
            catch (Exception exp) {
                Trace.TraceError(exp.Message);
                Trace.TraceError(exp.StackTrace);
            }
            InitializeComponent();
        }


        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            
        }

        private void Expander_MouseDown(object sender, MouseButtonEventArgs e)
        {
            MessageBox.Show(sender.ToString());
        }



        //public string Status { get; set; }
    }
}
