﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace MoneyManagerNET.Presentation.ViewModel
{
    public class SummaryOfStocksReportViewModel : ReportViewModelBase
    {
        
        public AccountSummaryGroup RootGroup { get; set; }
        public override void Execute()
        {
            base.Execute();

            this.Investments = App.Storage.Select<Model.IStockInvestment>().ToArray();
        }

        public ICollection<Model.IStockInvestment> Investments { get; protected set; }

        public SummaryOfStocksReportViewModel()
        {
            this.Header = "SummaryOfAccountsReportViewModel";
        }
    }

    

}
